%define api 1.0
%define major 1
%define libname %mklibname %{name} %{api} %{major}
%define devname %mklibname %{name} -d
%define sdevname %mklibname %{name} -d -s

%define libdebug %mklibname %{name}-debug %{api} %{major}
%define devdebug %mklibname %{name}-debug -d
%define sdevdebug %mklibname %{name}-debug -d -s

%define show_all_cmds       1
%define broken_fed_dbg_opts 1

%if %{show_all_cmds}
%define policy_cflags_hide HIDE=
%else
%define policy_cflags_hide %{nil}
%endif

%if %{broken_fed_dbg_opts}
# Variable name explains itself.
%define policy_cflags_broken DBG_ONLY_BAD_POLICIES_HAVE_THIS_EMPTY_CFLAGS=
%else
%define policy_cflags_broken %{nil}
%endif

%define policy_cflags %{policy_cflags_hide} %{policy_cflags_broken}

Summary:	String library, very low memory overhead, simple to import
Name:		ustr
Version:	1.0.4
Release:	8
License:	MIT or LGPLv2+ or BSD
Group:		System/Libraries
Url:		http://www.and.org/ustr/
Source0:	http://www.and.org/ustr/%{version}/%{name}-%{version}.tar.bz2

%description
Micro string library, very low overhead from plain strdup() (Ave. 44% for
0-20B strings). Very easy to use in existing C code. At it's simplest you can
just include a single header file into your .c and start using it.
This package also distributes pre-built shared libraries.

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	String library, very low memory overhead, simple to import
Group:		System/Libraries
Provides:	%{name} = %{EVRD}
Conflicts:	%{_lib}ustr1 < 1.0.4-7
Obsoletes:	%{_lib}ustr1 < 1.0.4-7

%description -n %{libname}
Micro string library, very low overhead from plain strdup() (Ave. 44% for
0-20B strings). Very easy to use in existing C code. At it's simplest you can
just include a single header file into your .c and start using it.
This package also distributes pre-built shared libraries.

%files -n %{libname}
%doc ChangeLog LICENSE* README NEWS
%{_libdir}/libustr-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
Header files for the Ustr string library, and the .so to link with.
Also includes a %{name}.pc file for pkg-config usage.
Includes the ustr-import tool, for if you jsut want to include
the code in your projects ... you don't have to link to the shared lib.

%files -n %{devname}
%{_datadir}/ustr-%{version}
%{_bindir}/ustr-import
%{_includedir}/ustr.h
%{_includedir}/ustr-*.h
%exclude %{_includedir}/ustr*debug.h
%{_libdir}/pkgconfig/ustr.pc
%{_libdir}/libustr.so
%{_datadir}/doc/ustr-devel-%{version}
%{_mandir}/man1/*
%{_mandir}/man3/*

#----------------------------------------------------------------------------

%package -n %{sdevname}
Summary:	Static development files for %{name}
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	%{name}-static-devel = %{EVRD}

%description -n %{sdevname}
Static library for the Ustr string library.

%files -n %{sdevname}
%{_libdir}/libustr.a

#----------------------------------------------------------------------------

%package -n %{libdebug}
Summary:	Development files for %{name}, with debugging options turned on
Group:		Development/C
Provides:	%{name}-debug = %{EVRD}
Conflicts:	%{_lib}ustr1-debug < 1.0.4-7
Obsoletes:	%{_lib}ustr1-debug < 1.0.4-7

%description -n %{libdebug}
Dynamic libraries for a debug build of the Ustr string library.

%files -n %{libdebug}
%{_libdir}/libustr-debug-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devdebug}
Summary:	Development files for %{name}, with debugging options turned on
Group:		Development/C
Requires:	%{libdebug} = %{EVRD}
Requires:	%{name}-devel = %{EVRD}
Provides:	%{name}-debug-devel = %{EVRD}

%description -n %{devdebug}
Header files and dynamic libraries for a debug build of the Ustr string
library. Also includes a %{name}-debug.pc file for pkg-config usage.

%files -n %{devdebug}
%{_libdir}/libustr-debug.so
%{_includedir}/ustr-debug.h
%{_includedir}/ustr-conf-debug.h
%{_libdir}/pkgconfig/ustr-debug.pc

#----------------------------------------------------------------------------

%package -n %{sdevdebug}
Summary:	Static development files for %{name}, with debugging options turned on
Group:		Development/C
Requires:	%{devdebug} = %{EVRD}
Requires:	%{sdevname} = %{EVRD}
Provides:	%{name}-debug-static-devel = %{EVRD}

%description -n %{sdevdebug}
Static library for the debug build of the Ustr string library.

%files -n %{sdevdebug}
%{_libdir}/libustr-debug.a

#----------------------------------------------------------------------------

%prep
%setup -q

%build
%make all-shared CFLAGS="%{optflags} -fPIC" %{policy_cflags}

%install
%makeinstall LDCONFIG=/bin/true HIDE=

%check
%make check %{policy_cflags}


%changelog

* Sun Feb 22 2015 Alexander Lakhin <a.lahin@ntcit-rosa.ru> 1.0.4-8
- (1d252c6) MassBuild#656: Increase release tag


